Subject: xorg-7.0 freezes on gentoo ppc64 linux with 9800 card

From: "Yang Dehua" <[email-masked]>
Date: Wed, 5 Apr 2006 07:59:38 +0800

I just bought a mac 9800xt card to replace my 9600pro on my G5 running gentoo ppc64 linux(2006.0, 64-bit userland). The system worked fine until I started xorg-7.0: the screen blacked and the keyboard and mouse were not responding any more, so I had to shutdown the machine. The same X config worked well with 9600pro card(64M). 
I tried also ppc32 chroot on my system with xorg-6.8.2, it worked as expected. The last part of Xorg.0.log file is as follows, which was left by the broken xorg-7.0: 

 (==) RADEON(0): RGB weight 888 
(II) RADEON(0): Using 8 bits per RGB (8 bit DAC) 
(II) Loading sub module "fbdevhw" 
(II) LoadModule: "fbdevhw" 
(II) Reloading /usr/lib64/xorg/modules/linux/libfbdevhw.so 
(**) RADEON(0): Using framebuffer device 
(--) RADEON(0): Chipset: "ATI Radeon 9800PRO NH (AGP)" (ChipID = 0x4e48) 
(--) RADEON(0): Linear framebuffer at 0xa0000000 
(--) RADEON(0): BIOS at 0x90020000 
(--) RADEON(0): VideoRAM: 262144 kByte (256 bit DDR SDRAM) 
(II) RADEON(0): Color tiling disabled 
(II) Loading sub module "ddc" 
(II) LoadModule: "ddc" 
(II) Loading /usr/lib64/xorg/modules/libddc.so 
(II) Module ddc: vendor="X.Org Foundation" 
compiled for 7.0.0, module version = 1.0.0 
ABI class: X.Org Video Driver, version 0.8 
(II) Loading sub module "i2c" 
(II) LoadModule: "i2c" 
(II) Loading /usr/lib64/xorg/modules/libi2c.so 
(II) Module i2c: vendor="X.Org Foundation" 
compiled for 7.0.0, module version = 1.2.0 
ABI class: X.Org Video Driver, version 0.8 
(II) RADEON(0): I2C bus "DDC" initialized. 
(WW) RADEON(0): Video BIOS not detected in PCI space! 
(WW) RADEON(0): Attempting to read Video BIOS from legacy ISA space! 
(WW) RADEON(0): Unrecognized BIOS signature, BIOS data will not be used 
(WW) RADEON(0): Invalid Monitor type specified for 2nd port 
(**) RADEON(0): MonitorLayout Option: 
Monitor1--Type TMDS, Monitor2--Type 

(II) RADEON(0): I2C device "DDC:ddc2" registered at address 0xA0. 
(II) RADEON(0): I2C device "DDC:ddc2" removed. 
(II) RADEON(0): DDC Type: 2, Detected Type: 3 

Here is some info about my card and X:

# lspci
... ...
f0:10.0 VGA compatible controller: ATI Technologies Inc Radeon R350 [Radeon 9800 Pro] (prog-if 00 [VGA])
 Subsystem: ATI Technologies Inc Radeon R350 [Radeon 9800 Pro]
 Flags: bus master, stepping, 66MHz, medium devsel, latency 16, IRQ 48
 Memory at a0000000 (32-bit, prefetchable) [size=256M]
 I/O ports at f0000400 [size=256]
 Memory at 90000000 (32-bit, non-prefetchable) [size=64K]
 Expansion ROM at 90020000 [size=128K]
 Capabilities: [58] AGP version 3.0
 Capabilities: [50] Power Management version 2

# X -version
X Window System Version 7.0.0
Release Date: 21 December 2005
X Protocol Version 11, Revision 0, Release 7.0
Build Operating System:Linux 2.6.16-ck2 ppc64
Current Operating System: Linux localhost 2.6.16-ck3 #1 SMP Mon Apr 3 19:12:29 CST 2006 ppc64
Build Date: 02 April 2006
 Before reporting problems, check http://wiki.x.org
 to make sure that you have the latest version.
Module Loader present

Xorg.conf:
... ...
 Section "Device" 
Identifier "Card0" 
### Available Driver options: 
Option "ColorTiling" "false" # True has trouble with latest xorg 
Option "BackingStore" "true" # Increases performance 
Option "EnablePageFlip" "true" # Increases performance 
#Option "SWcursor" "false" # Use Software Cursor 
Option "NoAccel" "false" # Disable Hardware Acceleration 
Option "AGPMode" "8" # Set AGP data transfer rate, DRI only 
#Option "AccelMethod" "EXA" # New RenderAccel 
#Option "AGPFastWrite" "false" # Use AGP Fast Write, DRI only 
Option "RenderAccel" "true" # Hardware acceleration 
#Option "DCCMode" "false" # Use querried modes from monitor 
Option "MonitorLayout" "TMDS" # Enable this for Apple DVI LCDs 
### See "man radeon" for additional options 
Option "UseFBDev" "True" #"False" 
Driver "radeon" 
BusID "PCI:240:16:0" 
EndSection 
... ...

I noticed the 9800XT card was identified as 9800PRO, R350, but it's R360 under MAC OSX. 
Is that specific for ppc64 linux 64-bit userland? I haven't tried xorg-6.8 or 6.9 on my ppc64 with 64-bit, but for 32-bit userland 6.8.2-r6 has no problems.
Thank you in advance, any help is highly appreciated.

Dehua